#include <stdio.h>
#include <string.h>

#define VMAX 1100
#define NMAX 100100

int prim[VMAX], poz[NMAX];
int N, K, i, x, p;
long long num;

void ciur_Eratostene()
{
	int i, j;

	for (i = 1; i < VMAX; i++)
		prim[i] = 1;

	prim[1] = 0;

	for (i = 2; i < VMAX; i++)
		if (prim[i])
		{
			j = 2 * i;
			while (j < VMAX)
			{
				prim[j] = 0;
				j += i;
			}
		}
}

int main()
{
	freopen("kprime.in", "r", stdin);
	freopen("kprime.out", "w", stdout);

	ciur_Eratostene();
	poz[0] = 0;

	scanf("%d %d", &N, &K);
	for (i = 1, p = 0; i <= N; i++)
	{
		scanf("%d", &x);
		if (prim[x])
		{
			p++;
			poz[p] = i;
		}
	}

	poz[p+1] = N + 1;

	num = 0;
	for (i = K; i <= p; i++)
		num += (long long) (poz[i-K+1] - poz[i - K]) * (long long) (poz[i + 1] - poz[i]);

	printf("%lld\n", num);

	return 0;
}
