#include <stdio.h>
#include <string.h>

#define NMAX 2010

char A[NMAX][NMAX], row[NMAX];
int hstk[NMAX], colstk[NMAX], sumhstk[NMAX], hup[NMAX];
int i, j, k, lin, col, N, niv;
long long cnt;

int main()
{
	freopen("covor.in", "r", stdin);
	fgets(row, NMAX - 1, stdin);
	sscanf(row, "%d", &N);

	for (i = 1; i <= N; i++)
		fgets(&A[i][1], NMAX - 3, stdin);

	cnt = 0;

	memset(hup, 0, sizeof(hup));

	for (lin = 1; lin <= N; lin++)
	{
		niv = 0;
		hstk[niv] = 0;
		colstk[niv] = 0;
		sumhstk[niv] = 0;
		
		for (col = 1; col <= N; col++)
			if (A[lin][col] == '1')
			{
				niv = 0;
				hstk[niv] = 0;
				colstk[niv] = col;
				sumhstk[niv] = 0;
				hup[col] = 0;
			}
			else
			{
				hup[col]++;

				while (niv > 0 && hstk[niv] >= hup[col])
					niv--;

				niv++;
				hstk[niv] = hup[col];
				colstk[niv] = col;
				sumhstk[niv] = sumhstk[niv - 1] + (col - colstk[niv - 1]) * hup[col];

				cnt += (long long) sumhstk[niv];
			}
	}
	
	freopen("covor.out", "w", stdout);
	printf("%lld\n", cnt);

	return 0;
}