#include <stdio.h>
//#include <time.h>

#define NMAX 200100

#define max(a, b) ((a) >= (b) ? (a) : (b))
#define min(a, b) ((a) <= (b) ? (a) : (b))

int cmin[NMAX], cmax[NMAX], dmin, dmax;
int dqmin[NMAX], imin[NMAX], jmin, jmax, limin, lsmin;
int dqmax[NMAX], imax[NMAX], limax, lsmax;
int i, j, k, N, lmax, len, lmax1, lmax0;

void solve()
{
	limin = limax = 0;
	lsmin = lsmax = -1;

	for (j = jmin = jmax = 1, i = 1; i <= N; i++)
	{
		dmin = i + cmin[i];
		dmax = i + cmax[i];

		while (limin <= lsmin && dqmin[lsmin] > dmax)
			lsmin--;
		lsmin++;
		dqmin[lsmin] = dmax;
		imin[lsmin] = i;

		while (limax <= lsmax && dqmax[lsmax] < dmin)
			lsmax--;
		lsmax++;
		dqmax[lsmax] = dmin;
		imax[lsmax] = i;

		while (dqmax[limax] > dqmin[limin])
		{
			if (imin[limin] < imax[limax])
			{
				jmin = imin[limin] + 1;
				limin++;
			}
			else
			if (imin[limin] > imax[limax])
			{
				jmax = imax[limax] + 1;
				limax++;
			}
			else
			{
				jmin = imin[limin] + 1;
				jmax = imax[limax] + 1;
				limin++;
				limax++;
			}
		}

		j = max(jmin, jmax);
		len = i - j + 1;
		lmax = max(lmax, len);
	}
}

#define LINESIZE 5000
char line[LINESIZE];
int p;

int main()
{
	//int tstart = clock();

	freopen("diagonala.in", "r", stdin);
	//scanf("%d", &N);
	fgets(line, LINESIZE - 2, stdin);
	for (p = 0; line[p] < '0' || line[p] > '9'; p++);
	N = 0;
	for (; line[p] >= '0' && line[p] <= '9'; p++)
		N = N * 10 + (line[p] - '0');
	
	for (i = 1; i <= N; i++)
	{
		//scanf("%d %d", &cmin[i], &cmax[i]);
		fgets(line, LINESIZE - 2, stdin);
		for (p = 0; line[p] < '0' || line[p] > '9'; p++);
		cmin[i] = 0;
		for (; line[p] >= '0' && line[p] <= '9'; p++)
			cmin[i] = cmin[i] * 10 + (line[p] - '0');
		for (; line[p] < '0' || line[p] > '9'; p++);
		cmax[i] = 0;
		for (; line[p] >= '0' && line[p] <= '9'; p++)
			cmax[i] = cmax[i] * 10 + (line[p] - '0');
	}

	lmax = 0;
	solve();

	for (i = 1; i <= N / 2; i++)
	{
		k = cmin[i];
		cmin[i] = cmin[N - i + 1];
		cmin[N - i + 1] = k;

		k = cmax[i];
		cmax[i] = cmax[N - i + 1];
		cmax[N - i + 1] = k;
	}

	//fprintf(stderr, "Lmax1=%d\n", lmax);

	solve();

	freopen("diagonala.out", "w", stdout);
	printf("%d\n", lmax);

	//fprintf(stderr, "Lmax=%d\n", lmax);
	//fprintf(stderr, "Duration = %.3lf sec\n", ((double) (clock() - tstart)) / CLOCKS_PER_SEC);

	return 0;
}