#include <stdio.h>
#include <string.h>

#define LMAX 1024
#define NCHARS ('z' - 'a' + 1)
#define KMAX 1000000000000000000LL

int i, j, poz, L, N, T;
int next[LMAX][NCHARS];
long long K, ns[LMAX][NCHARS];
char s[LMAX], sol[LMAX], ch, found;

int main()
{
	freopen("kss.in", "r", stdin);
	freopen("kss.out", "w", stdout);
	scanf("%d", &T);

	while (T--)
	{
		scanf("%d %lld %s", &N, &K, s + 1);

		memset(ns, 0, sizeof(ns));
		memset(next, 0, sizeof(next));

		ns[N][s[N] - 'a'] = 1;
		next[N][s[N] - 'a'] = N;

		for (i = N - 1; i >= 1; i--)
		{
			for (ch = 'a'; ch <= 'z'; ch++)
			{
				if (ch != s[i])
				{
					ns[i][ch - 'a'] = ns[i + 1][ch - 'a'];
					next[i][ch - 'a'] = next[i + 1][ch - 'a'];
				}
			
				if (KMAX - ns[i + 1][ch - 'a'] > ns[i][s[i] - 'a'])
					ns[i][s[i] - 'a'] += ns[i + 1][ch - 'a'];
				else
					ns[i][s[i] - 'a'] = KMAX;
			}

			if (ns[i][s[i] - 'a'] < KMAX)
				ns[i][s[i] - 'a']++;

			next[i][s[i] - 'a'] = i;
		}

		if (K == 1)
		{
			for (ch = 'a'; ch <= 'z'; ch++)
				if (ns[1][ch - 'a'] > 0)
				{
					printf("%c\n", ch);
					break;
				}
		}
		else
		{
			L = 0;
			poz = 1;

			while (K > 0 && poz <= N)
			{
				found = 0;
				for (ch = 'a'; ch <= 'z'; ch++)
					if (K > ns[poz][ch - 'a'])
						K -= ns[poz][ch - 'a'];
					else
					{
						L++;
						sol[L] = ch;
						K--;
						poz = next[poz][ch - 'a'] + 1;
						found = 1;
						break;
					}

				if (!found)
					break;
			}

			if (!found)
				printf("-1\n");
			else
			{
				sol[L + 1] = 0;
				printf("%s\n", sol + 1);
			}
		}
	}
}
