#include <stdio.h>

#define NMAX 1000100

int p[NMAX], stk[NMAX];
int f[NMAX], prev[NMAX], curr[NMAX];
int t[NMAX], /*size[NMAX],*/ cnt[NMAX];
int i, j, k, top, N, M, tx, ty, r;
long long sumcnt;

int main()
{
	freopen("compact.in", "r", stdin);
	scanf("%d", &N);
	for (i = 1; i <= N; i++)
		scanf("%d", &p[i]);

	for (i = 0; i <= N + 1; i++)
		cnt[i] = 0;

	// minimum stacks from N down to 1
	for (i = 0; i <= N + 1; i++)
		prev[i] = curr[i] = 0;

	p[N + 1] = 0;
	stk[top = 1] = N + 1;

	M = 0;
	for (i = N; i >= 1; i--)
	{
		while (top >= 1 && p[i] < p[stk[top]])
			top--;

		//fprintf(stderr, "min interval: %d - %d\n", i, stk[top] - 1);
		cnt[i]++;

		// add i as a son of stk[top]
		M++;
		f[M] = i;

		if (!curr[stk[top]])
			curr[stk[top]] = M;
		else
		{
			prev[M] = curr[stk[top]];
			curr[stk[top]] = M;
		}

		top++;
		stk[top] = i;
	}

	// maximum stacks from 1 to N
	for (i = 1; i <= N; i++)
	{
		t[i] = 0;
		//size[i] = 1;
	}

	p[0] = N + 1;
	stk[top = 1] = 0;
	sumcnt = 0;

	for (i = 1; i <= N; i++)
	{
		while (top >= 1 && p[i] > p[stk[top]])
		{
			// Union(i, stk[top])
			tx = i;
			while (t[tx])
				tx = t[tx];

			ty = stk[top];
			while (t[ty])
				ty = t[ty];

			if (/*size[tx] > size[ty]*/ 1)
			{
				t[ty] = r = tx;
				cnt[tx] += cnt[ty];
				//size[tx] += size[ty];
			}
			else
			{
				t[tx] = r = ty;
				cnt[ty] += cnt[tx];
				//size[ty] += size[tx];
			}

			// path compression
			tx = i;
			while (tx != r)
			{
				ty = t[tx];
				t[tx] = r;
				tx = ty;
			}

			ty = stk[top];
			while (ty != r)
			{
				tx = t[ty];
				t[ty] = r;
				ty = tx;
			}

			// decrease the top of the stack
			top--;
		}

		// add i at the top of the stack
		top++;
		stk[top] = i;

		// remove some min intervals
		k = curr[i];
		while (k)
		{
			tx = f[k];
			while (t[tx])
				tx = t[tx];
			cnt[r = tx]--;

			// path compression
			tx = f[k];
			while (tx != r)
			{
				ty = t[tx];
				t[tx] = r;
				tx = ty;
			}
			
			// go to the next min-interval ending at the position i
			k = prev[k];
		}

		tx = i;
		while (t[tx])
			tx = t[tx];

		sumcnt += (long long) (cnt[tx]);
	}

	sumcnt -= (long long) N;
	for (i = 1; i <= N - 1; i++)
		if (p[i] < p[i + 1])
			sumcnt--;

	freopen("compact.out", "w", stdout);
	printf("%lld\n", sumcnt);
	//fprintf(stderr, "OK: %lld\n", sumcnt);

	return 0;
}
