#include <stdio.h>

#define NKMAX 1000100
#define VMAX 100100
#define NMAX 50010

#define max(a, b) ((a) > (b) ? (a) : (b))

int lmax[VMAX], lmaxidx[VMAX];
int v[NKMAX], prev[NKMAX], sol[NMAX];
int i, j, N, K, c, Cmax, s, f, L, Lmax, pmax;

int main()
{
	freopen("cuburi5.in", "r", stdin);
	scanf("%d %d", &N, &K);

	Cmax = N * K;
	for (c = 1; c <= Cmax; c++)
	{
		scanf("%d", &v[c]);
		prev[c] = 0;
	}

	for (i = 0; i < VMAX; i++)
		lmax[i] = lmaxidx[i] = 0;

	// do the DP
	for (i = N; i >= 1; i--)
	{
		L = c = 0;

		s = (i - 1) * K + 1;
		f = i * K;

		for (j = s; j <= f; j++)
			if (lmax[v[j]] > L)
			{
				L = lmax[v[j]];
				c = lmaxidx[v[j]];
			}
			else
			if (lmax[v[j]] == L && lmaxidx[v[j]] < c)
				c = lmaxidx[v[j]];

		L++;
		for (j = s; j <= f; j++)
		{
			lmax[v[j]] = L;
			lmaxidx[v[j]] = j;
			prev[j] = c;
		}
	}

	Lmax = pmax = 0;
	for (i = 0; i < VMAX; i++)
		if (lmax[i] > Lmax)
		{
			Lmax = lmax[i];
			pmax = lmaxidx[i];
		}
		else
		if (lmax[i] == Lmax && lmaxidx[i] < pmax)
			pmax = lmaxidx[i];

	c = 0;
	while (pmax > 0)
	{
		c++;
		sol[c] = ((pmax - 1) / K) + 1;
		pmax = prev[pmax];
	}

	freopen("cuburi5.out", "w", stdout);
	for (i = 1; i <= c; i++)
	{
		printf("%d", sol[i]);
		if (i < c)
			printf(" ");
	}

	printf("\n");

	return 0;
}
