#include <stdio.h>
#include <vector>

using namespace std;

#define NMAX 200100

#define min(a,b) ((a) < (b) ? (a) : (b))
#define max(a,b) ((a) > (b) ? (a) : (b))

char ntype[NMAX];
int t[NMAX], f[NMAX], next[NMAX], first[NMAX], curr[NMAX], q[NMAX];
int nmaxedges[NMAX][2], nminpaths[NMAX][2];
int i, j, k, r, N, M, sume, sump, cnt, difemin, difpmin, difemin2, difpmin2, nf, p1, p2;

int main()
{
	// read the input data

	freopen("tree.in", "r", stdin);
	scanf("%d", &N);

	for (i = 1; i <= N; i++)
		first[i] = curr[i] = 0;

	M = 0;
	for (i = 1; i <= N; i++)
	{
		scanf("%d", &t[i]);

		if (!t[i])
			r = i;
		else
		{
			M++;
			f[M] = i;
			next[M] = 0;

			if (!first[t[i]])
				first[t[i]] = curr[t[i]] = M;
			else
			{
				next[curr[t[i]]] = M;
				curr[t[i]] = M;
			}
		}
	}

	// generate an ordering of the sons
	q[j = 1] = r;
	for (i = 1; i <= j; i++)
	{
		k = first[q[i]];
		while (k)
		{
			j++;
			q[j] = f[k];
			k = next[k];
		}
	}

	// do the DP
	for (i = N; i >= 1; i--)
	{
		if (!first[q[i]])
		{
			nmaxedges[q[i]][0] = nmaxedges[q[i]][1] = 0;
			nminpaths[q[i]][0] = nminpaths[q[i]][1] = 1;
		}
		else
		{
			// compute nmaxedges[q[i]][0] and nminpaths[q[i]][0]
			sume = sump = cnt = nf = 0;
			k = first[q[i]];
			while (k)
			{
				if ((nmaxedges[f[k]][0] > nmaxedges[f[k]][1]) ||
					((nmaxedges[f[k]][0] == nmaxedges[f[k]][1]) && (nminpaths[f[k]][0] <= nminpaths[f[k]][1])))
				{
					sume += nmaxedges[f[k]][0];
					sump += nminpaths[f[k]][0];
					ntype[f[k]] = 0;
					cnt++;
				}
				else
				{
					sume += nmaxedges[f[k]][1];
					sump += nminpaths[f[k]][1];
					ntype[f[k]] = 1;
				}

				nf++;
				k = next[k];
			}

			if (cnt >= 1)
			{
				nmaxedges[q[i]][0] = sume + 1;
				nminpaths[q[i]][0] = sump;
			}
			else
			{
				nmaxedges[q[i]][0] = sume;
				nminpaths[q[i]][0] = sump + 1;

				difpmin = N + 1;
				p1 = 0;

				k = first[q[i]];
				while (k)
				{
					if ((ntype[f[k]] == 1) && (nmaxedges[f[k]][0] == nmaxedges[f[k]][1]) && (nminpaths[f[k]][0] - nminpaths[f[k]][1] < difpmin))
					{
						difpmin = nminpaths[f[k]][0] - nminpaths[f[k]][1];
						p1 = f[k];
					}

					k = next[k];
				}

				if (p1 > 0)
				{
					nmaxedges[q[i]][0] = sume + 1;
					nminpaths[q[i]][1] = sump + difpmin;
				}
				else
				{
					difpmin = N + 1;
					p1 = 0;

					k = first[q[i]];
					while (k)
					{
						if ((ntype[f[k]] == 1) && (nmaxedges[f[k]][0] == nmaxedges[f[k]][1] - 1) && (nminpaths[f[k]][0] - nminpaths[f[k]][1] < difpmin))
						{
							difpmin = nminpaths[f[k]][0] - nminpaths[f[k]][1];
							p1 = f[k];
						}

						k = next[k];
					}

					if (p1 > 0 && difpmin <= -2)
					{
						nmaxedges[q[i]][0] = sume;
						nminpaths[q[i]][0] = sump + difpmin;
					}
				}
			}

			// compute nmaxedges[q[i]][1] and nminpaths[q[i]][1]
			nmaxedges[q[i]][1] = nmaxedges[q[i]][0];
			nminpaths[q[i]][1] = nminpaths[q[i]][0];

			if (nf >= 2)
			{
				if (cnt >= 2)
				{
					nmaxedges[q[i]][1] = sume + 2;
					nminpaths[q[i]][1] = sump - 1;
				}
				else
				if (cnt == 1)
				{
					difemin = difpmin = N + 1;
					k = first[q[i]];
					while (k)
					{
						if (((nmaxedges[f[k]][1] - nmaxedges[f[k]][0] < difemin) ||
							((nmaxedges[f[k]][1] - nmaxedges[f[k]][0] == difemin) && (nminpaths[f[k]][0] - nminpaths[f[k]][1] < difpmin))) && (ntype[f[k]] == 1))
						{
							difemin = nmaxedges[f[k]][1] - nmaxedges[f[k]][0];
							difpmin = nminpaths[f[k]][0] - nminpaths[f[k]][1];
							p1 = f[k];
						}

						k = next[k];
					}

					if ((sume - difemin + 2 > nmaxedges[q[i]][1]) ||
						((sume - difemin + 2 == nmaxedges[q[i]][1]) && (sump + difpmin < nminpaths[q[i]][1])))
					{
						nmaxedges[q[i]][1] = sume - difemin + 2;
						nminpaths[q[i]][1] = sump + difpmin;
					}
				}
				else // cnt == 0
				{
					difemin = difpmin = N + 1;
					k = first[q[i]];
					while (k)
					{
						if (((nmaxedges[f[k]][1] - nmaxedges[f[k]][0] < difemin) ||
							((nmaxedges[f[k]][1] - nmaxedges[f[k]][0] == difemin) && (nminpaths[f[k]][0] - nminpaths[f[k]][1] < difpmin))) && (ntype[f[k]] == 1))
						{
							difemin = nmaxedges[f[k]][1] - nmaxedges[f[k]][0];
							difpmin = nminpaths[f[k]][0] - nminpaths[f[k]][1];
							p1 = f[k];
						}

						k = next[k];
					}

					difemin2 = difpmin2 = N + 1;
					k = first[q[i]];
					while (k)
					{
						if (((nmaxedges[f[k]][1] - nmaxedges[f[k]][0] < difemin2) ||
							((nmaxedges[f[k]][1] - nmaxedges[f[k]][0] == difemin2) && (nminpaths[f[k]][0] - nminpaths[f[k]][1] < difpmin2))) && (ntype[f[k]] == 1) && (f[k] != p1))
						{
							difemin2 = nmaxedges[f[k]][1] - nmaxedges[f[k]][0];
							difpmin2 = nminpaths[f[k]][0] - nminpaths[f[k]][1];
							p2 = f[k];
						}

						k = next[k];
					}

					if ((sume - difemin - difemin2 + 2 > nmaxedges[q[i]][1]) ||
						((sume - difemin - difemin2 + 2 == nmaxedges[q[i]][1]) && (sump + difpmin + difpmin2 < nminpaths[q[i]][1])))
					{
						nmaxedges[q[i]][1] = sume - difemin - difemin2 + 2;
						nminpaths[q[i]][1] = sump + difpmin + difpmin2;
					}
				}
			}
		}
	}

	freopen("tree.out", "w", stdout);
	printf("%d\n", min(N - 1 - nmaxedges[r][0] + nminpaths[r][0], N - 1 - nmaxedges[r][1] + nminpaths[r][1]));

	return 0;
}
